%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%define debug_package %{nil} 

%define _rbindir %{_exec_prefix}/bin
########################################################################
# On CentOS/RHEL, if the Software Configurations Library is installed
# and Python 2.7 is installed, then it is used. This is only available
# on CentOS 6.5 for the x86_64 architecture, at this time.
########################################################################
%define __SCL	%(if [ -d /opt/rh/python27 ]; then echo 1; else echo 0; fi)

%if 0%{?__SCL} > 0 
	%define PYTHON     python27
	%define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
	%define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
	%define python_sitelib %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)"' | scl enable python27 -)
	%define _SCL_base %(echo $(dirname $(dirname `echo which python | scl enable python27 -`)))
	%define _bindir %(dirname `echo which python | scl enable python27 -`)
	%define _datadir %{_SCL_base}/share
	%define _mandir %{_datadir}/man
	%define _docdir %{_datadir}/doc
	%define __os_install_post	\
	    /usr/lib/rpm/redhat/brp-compress; \
	    %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}}; \
	    /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip}; \
	    /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump}; \
	    echo /usr/lib/rpm/brp-python-bytecompile python27 | scl enable %{PYTHON} - ; \
	    /usr/lib/rpm/redhat/brp-python-hardlink; \
	    %{!?__jar_repack:/usr/lib/rpm/redhat/brp-java-repack-jars}
%else
	%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
%endif

%define name dfvfs
%define version 20180831
%define unmangled_version 20180831
%define release 1%{?dist}
%define	_PYTHON %(basename %{__python})

Summary:	Digital Forensics Virtual File System (dfVFS).
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	%{name}-%{unmangled_version}.tar.gz
License:	Apache License, Version 2.0
Group:		Development/Libraries
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix:		%{_prefix}
BuildArch:	noarch
Vendor:		"Log2Timeline developer" <log2timeline-dev@googlegroups.com>
Url:		https://github.com/log2timeline/dfvfs/wiki
%if 0%{?__SCL} > 0
BuildRequires:	python27-python-setuptools
Requires:	python27-python-setuptools
%else
BuildRequires:	python(abi) => 2.7
BuildRequires:	%{_PYTHON}-devel
Requires:	%{_PYTHON}
%endif
Requires:	python-construct >= 2.5.2
Requires:	python-construct <= 2.5.3
%if 0%{?fedora} >= 24
Requires:	python2-crypto >= 2.6
%else
Requires:	python-crypto >= 2.6
%endif
Requires:	python-dfdatetime >= 20180324
Requires:	dtfabric >= 20170524
Requires:	python-backports-lzma 
Requires:	libbde-python >= 20140531
Requires:	libewf-python >= 20131210
Requires:	libfsntfs-python >= 20151130
Requires:	libfvde-python >= 20160719
Requires:	libfwnt-python >= 20160418
Requires:	libqcow-python >= 20131204
Requires:	libsigscan-python >= 20150627
Requires:	libsmdev-python >= 20140529
Requires:	libsmraw-python >= 20140612
Requires:	pytsk3 >= 20160721
Requires:	libvhdi-python >= 20131210
Requires:	libvmdk-python >= 20140421
Requires:	libvshadow-python >= 20160109
Requires:	libvslvm-python >= 20160109
Requires:	python-six >= 1.1.0
Requires:	sqlite >= 3.7.8
Requires:	protobuf-python
Requires:	sleuthkit-libs >= 4.1.2

%description
dfVFS, or Digital Forensics Virtual File System, is a Python module that provides read-only access to file-system objects from various storage media types and file formats.

%prep
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if 0%{?__SCL} > 0
cat > /tmp//pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x /tmp/pythondeps.sh
%define __python_requires /tmp/pythondeps.sh
%endif
%setup -n %{name}-%{unmangled_version} -n %{name}-%{unmangled_version}

%build
%if 0%{?__SCL} > 0
	echo python setup.py build | scl enable python27 -
%else
	%{__python} setup.py build
%endif

%install
%if 0%{?__SCL} > 0
	echo python setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES | scl enable python27 -
%else
	%{__python} setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files -f INSTALLED_FILES
%defattr(-,root,root)

%changelog
* Fri Aug 31 2018 Lawrence R. Rogers <lrr@cert.org> 20180831-1
* Release 20180831-1
	Version from 20180831

* Mon Aug 27 2018 Lawrence R. Rogers <lrr@cert.org> 20180827-1
* Release 20180827-1
	Version from 20180827

* Tue Jul  3 2018 Lawrence R. Rogers <lrr@cert.org> 20180703-1
* Release 20180703-1
	Version from 20180703

* Thu May 10 2018 Lawrence R. Rogers <lrr@cert.org> 20180510-1
* Release 20180510-1
	Version from 20180510

* Mon Mar 26 2018 Lawrence R. Rogers <lrr@cert.org> 20180326-1
* Release 20180326-1
	Version from 20180326

* Sat Dec 30 2017 Lawrence R. Rogers <lrr@cert.org> 20171228-1
* Release 20171228-1
	Version from 20171230

* Thu Dec 28 2017 Lawrence R. Rogers <lrr@cert.org> 20171228-1
* Release 20171228-1
	Version from 20171228

* Sun Dec 17 2017 Lawrence R. Rogers <lrr@cert.org> 20171217-1
* Release 20171217-1
	Version from 20171217

* Sun Dec  3 2017 Lawrence R. Rogers <lrr@cert.org> 20171203-1
* Release 20171203-1
	Version from 20171203

* Sun Oct 22 2017 Lawrence R. Rogers <lrr@cert.org> 20171022-1
* Release 20171022-1
	Version from 20171022

* Sun Jul 23 2017 Lawrence R. Rogers <lrr@cert.org> 20170723-1
* Release 20170723-1
	Version from 20170723

* Fri Mar 24 2017 Lawrence R. Rogers <lrr@cert.org> 20170324-1
* Release 20170324-1
	Version from 20170324

* Tue Oct 25 2016 Lawrence R. Rogers <lrr@cert.org> 20160918-2
* Release 20160918-2
	Changed dependency from pytsk to pytsk3.

* Sun Sep 20 2016 Lawrence R. Rogers <lrr@cert.org> 20160918-1
* Release 20160918-1
	Version from 20160918

* Tue Jul 27 2016 Lawrence R. Rogers <lrr@cert.org> 20160726-1
* Release 20160726-1
	Version built on 20160726 but using source code dated 20160306

* Mon Jul  4 2016 Lawrence R. Rogers <lrr@cert.org> 20160704-1
* Release 20160704-1
	Version from 20160704
	Now also requires libfwnt-python >= 20160418
	Now also requires python-dfdatetime >= 20160610

* Sun Mar  6 2016 Lawrence R. Rogers <lrr@cert.org> 20160306-1
* Release 20160306-1
	Version from 20160306

* Wed Feb  3 2016 Lawrence R. Rogers <lrr@cert.org> 20160108-1
* Release 20160108-1
	Version from 20160108

* Fri Jan  8 2016 Lawrence R. Rogers <lrr@cert.org> 20160108-1
* Release 20160108-1
	Version from 20160108

* Sun Dec 27 2015 Lawrence R. Rogers <lrr@cert.org> 20151227-1
* Release 20151227-1
	Version from 20151227

* Fri Dec 18 2015 Lawrence R. Rogers <lrr@cert.org> 20151218-1
* Release 20151218-1
	Version from 20151218

* Thu Oct  8 2015 Lawrence R. Rogers <lrr@cert.org> 20151008-1
* Release 20151008-1
	Version from 20151008

* Tue Sep 15 2015 Lawrence R. Rogers <lrr@cert.org> 20150915-1
* Release 20150915-1
	Version from 20150915

* Thu Jul 30 2015 Lawrence R. Rogers <lrr@cert.org> 20150730-1
* Release 20150730-1
	Version from 20150730

* Tue Jun 30 2015 Lawrence R. Rogers <lrr@cert.org> 20150630-1
* Release 20150708-1
	Version from 20150708

* Tue Jun 30 2015 Lawrence R. Rogers <lrr@cert.org> 20150630-1
* Release 20150630-1
	Version from 20150630

* Fri Jun 12 2015 Lawrence R. Rogers <lrr@cert.org> 20150612-1
* Release 20150612-1
	Version from 20150612

* Tue Apr 14 2015 Lawrence R. Rogers <lrr@cert.org> 20150414-1
* Release 20150414-1
	Version from 20150414

* Tue Mar  3 2015 Lawrence R. Rogers <lrr@cert.org> 20150303-1
* Release 20150303-1
	Version from 20150303

* Tue Feb 24 2015 Lawrence R. Rogers <lrr@cert.org> 20150224-1
* Release 20150224-1
	Version from 20150224

* Tue Feb 17 2015 Lawrence R. Rogers <lrr@cert.org> 20150217-1
* Release 20150217-1
	Version from 20150217

* Tue Feb  3 2015 Lawrence R. Rogers <lrr@cert.org> 20150203-1
* Release 20150203-1
	Version from 20150129 plus patch from 29150203

* Thu Jan 29 2015 Lawrence R. Rogers <lrr@cert.org> 20150129-1
* Release 20150129-1
	Version from 20150129

* Wed Jan 28 2015 Lawrence R. Rogers <lrr@cert.org> 20150127-1
* Release 20150127-1
	Version from 20150127

* Sat Dec 20 2014 Lawrence R. Rogers <lrr@cert.org> 20141220-1
* Release 20141220-1
	Version from 20141220

* Sat Nov  8 2014 Lawrence R. Rogers <lrr@cert.org> 20141108-1
* Release 20141108-1
	No longer scans VSS snapshot volumes by default.

* Tue Oct 28 2014 Lawrence R. Rogers <lrr@cert.org> 20141028-1
* Release 20141028-1
	See the changes listed at https://github.com/log2timeline/dfvfs

* Sun Sep 28 2014 Lawrence R. Rogers <lrr@cert.org> 20140928-1
* Release 20140928-1
	See the changes listed at https://code.google.com/p/dfvfs/source/list

* Sun Aug 24 2014 Lawrence R. Rogers <lrr@cert.org> 20140824-1
* Release 20140824-1
	See the changes listed at https://code.google.com/p/dfvfs/source/list

* Sun Jul 27 2014 Lawrence R. Rogers <lrr@cert.org> 20140727-1
* Release 120140727-1
	See the changes listed at https://code.google.com/p/dfvfs/source/list

* Wed Jul 02 2014 Lawrence R. Rogers <lrr@cert.org> 20140608-1
* Release 120140608-1
	Initial release
